#! /bin/bash
#
# :: Preparation Configuration File ::
#
echo ":: Preparation Configuration File ::"


# >> TESTING

echo "-[1/3 TESTING]-----------------"
(test -d tests && test -e tests/test.sh) && (cd tests && ./test.sh && cd ..)
test -e tests.successfull && (echo "(Testing was successfull.)" && echo && echo "-[2/3 PREPARING]---------------")


# >> CREATING DIRs
(test -e tests.successfull) && echo -n "Creating Directories..."
(test -e tests.successfull && test ! -e pre) && mkdir pre
(test -e tests.successfull && test ! -e pre/sources) && mkdir pre/sources
(test -e tests.successfull && test ! -e pre/scripts) && mkdir pre/scripts
(test -e tests.successfull && test ! -e pre/tests) && mkdir pre/tests
(test -e tests.successfull && test ! -e bin) && (mkdir bin)
test -e tests.successfull && echo "Ok."


# >> CREATING bin/ubl
test ! -e ubl.pre && echo "!! Missing ubl.pre !!"
(test -e tests.successfull && test -e ubl.pre) && (echo -n "Preparing UBL transaction..." && cp ubl.pre ubl.exe && mkbundle -o ubl ubl.exe > nul && rm -f ubl.exe)
test -e nul && rm -f nul
test -e ubl && (cp -f ubl pre/sources && rm -f ubl && cd bin && ln -sf ../pre/sources/ubl ../bin/ubl && cd ..)
(test -e ubl.pre && test -e bin/ubl) && echo "Ok."



# >> CREATING bin/wait
test ! -e wait.pre && echo "!! Missing wait.pre !!"
(test -e tests.successfull && test -e bin/ubl && test -e wait.pre) &&
(echo -n "Preparing WAIT transaction..." &&
cp wait.pre wait.exe &&
mkbundle -o 'wait' wait.exe > nul &&
rm -f wait.exe)
test -e nul && rm -f nul
test -e 'wait' &&
(cp -f 'wait' pre/sources &&
rm -f 'wait' &&
cd bin &&
ln -sf ../pre/sources/wait ../bin/wait &&
cd ..)
(test -e wait.pre && test -e bin/wait) && echo "Ok."


# >> CREATING bin/reparser
test ! -e wait.pre && echo "!! Missing reparser.pre !!"
(test -e tests.successfull && test -e bin/ubl && test -e bin/wait && test -e wait.pre) &&
(echo -n "Preparing REPARSE transaction..." &&
cp reparser.pre reparser.exe &&
mkbundle -o reparser reparser.exe > nul &&
rm -f reparser.exe)
test -e nul && rm -f nul
test -e reparser &&
(cp -f reparser pre/sources &&
rm -f reparser &&
cd bin &&
ln -sf ../pre/sources/reparser ../bin/reparser &&
cd ..)
(test -e reparser.pre && test -e bin/reparser) && echo "Ok."

# >> CREATING ./configure
test -e configure && rm -f configure
(test -e tests.successfull && test -e bin/ubl && test -e bin/wait && test -e bin/reparser) && (echo "(Preparation was successfull.)" && echo && echo "-[3/3 FINISHING]---------------")

(test -e tests.successfull && test -e bin/ubl && test -e bin/wait && test -e bin/reparser && test -e build.pre) && (echo -n "Creating \"./configure\"..." &&
bin/wait in 3 &&
cp -f build.pre configure &&
rm -f build.pre &&
chmod +x configure &&
rm -f ubl.pre &&
rm -f wait.pre &&
rm -f reparser.pre &&
rm -f tests/test1/test.sh &&
rm -f tests/test1/test.executable &&
rmdir tests/test1 &&
rm -f tests/test2/test.sh &&
rm -f tests/test2/test.executable &&
rmdir tests/test2 &&
rm -f tests/test.sh &&
rmdir tests &&
rm -f prepare.sh
echo "Ok." &&
echo "")

test -e tests.successfull && rm -f tests.successfull

